__global__ static void hst_cuda_oversample4_kernel(int num_proj, int proje, float *d_SLICE, float apos_off_x, float apos_off_y, int batch) {
    float res = 0;
    
    const int tidx = threadIdx.x;
    const int tidy = threadIdx.y;

    const int bidx = blockIdx.x * BLOCK_SIZE_X;
    const int bidy = batch + blockIdx.y * BLOCK_SIZE_Y;

    const float4 bd = {bidx + apos_off_x, bidy + apos_off_y, bidx + tidx + apos_off_x, bidy + tidy + apos_off_y};

    __shared__  float   cache_subh[BLOCK_SIZE_X][BLOCK_SIZE_Y + 1];
    __shared__  float   cache_sin[BLOCK_SIZE_Y];
    __shared__  float   cache[BLOCK_SIZE_Y][6 * BLOCK_SIZE_X];
    
//#pragma unroll 8
    float projf = tidy + 0.5;
    for (proje=0; proje<num_proj; proje += BLOCK_SIZE_Y) {
        float4 all = c_all[proje + tidy];
	int minh = (int)(all.z + bd.x * all.x - bd.y * all.y + all.w);

	cache_subh[tidx][tidy] = 4 * (all.z + bd.z * all.x - minh);
	if (tidx == 0) cache_sin[tidy] = 4 * all.y;


#pragma unroll 6
	for (int i = 0; i < 6; i++) {
	    int pos = i * BLOCK_SIZE_X + tidx;
	    cache[tidy][pos] = tex2D(tex_projes, minh + ((float)pos)/4, proje + projf);
	}

	__syncthreads();

#pragma unroll 16
	for (int i = 0; i < BLOCK_SIZE_Y; i++) {
	    minh = cache_subh[tidx][i] - bd.w * cache_sin[i];
	    res += cache[i][minh];
	}

	__syncthreads();

    }

    d_SLICE[ BLOCK_SIZE_X*gridDim.x*(bidy + tidy) + (bidx + tidx) ] = res;
}
