
#include"Python.h"
#include"structmember.h"
#include<string.h>

#include "numpy/arrayobject.h"

#ifdef LINUX
 #define _FILE_OFFSET_BITS  64
#endif


#define DEBUG(a)


 /* The error object to expose 
 */

static PyObject *ErrorObject;
#define onError(message)\
  { PyErr_SetString(ErrorObject, message); return NULL;}


#define  __SINO_Filter_name__  "SINO_Filter_Median"
#define __init__Filter__      initSINO_Filter_Median


    int hst_ffa8__(int* , int* , int* , float *, int* , float *, int *) ;
    int hst_ffs8__(int* , int* , int* , float *, int* , float *, int *) ;





void C_HST_EXPNT(int dim_exponts,int dim_fft2,int radix,float *EXPONENTS,
		 int *status)
{
  int hst_expnt__(int *maxdat,int * numdat,int * jump,float  *twiddle, int *status);
  
  hst_expnt__(&dim_exponts,&dim_fft2,&radix,EXPONENTS,status);
}


static char Filter_doc[]=
"/* "
"   Filter( item ,   SINO_FILTER_PARA     )"
"                     ^"
"                     dictionary"
" */";

static PyObject *
Filter(PyObject *self_a, PyObject *args)
{
  PyObject * A         ;

  PyObject * para_dict ;




  PyObject * dic_key;
  PyObject * dic_value;
  /* double threshold ; */

  int i;
  int dim_3,dim2,dim_1;

  float * a_data;

  float * sum_line;
  float * room_for_median;
  float tmp_swap;
  int count;
  int k,l;
  float  *EXPONENTS ;
  int status;
  int True=1;
  int dim_exponts;
  int dim_fft, two_power;

  float * FILTER;

  int slice_count, proj_count;


 if(!PyArg_ParseTuple(args,"OO:CDD_Filter",&A, &para_dict  ))
   return NULL;

 /* check the Objects */

  if(!PyArray_Check(A ))    onError("not a PyArray, argument 1");
  if(!PyDict_Check(para_dict ))        onError("not a PyDict, argument 2");

  /* check the types */

  if( ((PyArrayObject *) A )  ->descr->type_num != PyArray_FLOAT ) onError(" arg 1 is not an array of float " ) ;

  /* check n of dimensione */

  if( ((PyArrayObject *) A)->nd !=3)  onError(" arg 1 is not a 3D array " ) ;
 

  /* check contiguity */

  if(  ((PyArrayObject *) A) ->flags %2 == 0) onError(" array has to be contiguous");

  a_data = (float *) ((PyArrayObject *) A)->data;
 
  /* straighforward addressing scheme in case of contiguous memory. Or you'll need to use strides */
		      
  dim_3 = ((PyArrayObject *) A)->dimensions[0] ;
  dim2 = ((PyArrayObject *) A)->dimensions[1] ;
  dim_1 = ((PyArrayObject *) A)->dimensions[2] ;

  /* getting parameter(s) contained in the dictionary */
  
  dic_key = PyString_FromString("FILTER");
  dic_value =  PyDict_GetItem(para_dict , dic_key);
  Py_DECREF(dic_key); 
  if( dic_value == NULL) 
    onError(" unable to find the FILTER  key in the passed dictionary");
  
  if( !PyArray_Check(dic_value) ) 
    onError("supplied value for FILTER is not an ARRAY ");

  if( ((PyArrayObject *) dic_value )  ->descr->type_num != PyArray_FLOAT ) onError(" Filter is not an array of float " ) ;  

  if( ((PyArrayObject *)dic_value )->nd !=1)  onError(" Filter is not a 1D array " ) ;

  if(  ((PyArrayObject *)dic_value  ) ->flags %2 == 0) onError("Filter  has to be contiguous");



  two_power = (int)(log((2. * dim_1 - 1)) / log(2.0) + 0.9999);
  dim_fft = 1; for(i=1;i<two_power; i++) dim_fft*=2;


  if(  ((PyArrayObject *)dic_value )->dimensions[0] != dim_fft )  {
    printf("FILTER dimension should be = %d \n", dim_fft);
    onError("Filter  has wrong dimension, must correspond to the padded slice lenght ( power of 2 lenght)");
  }
  

  /* trusting passed value */
  FILTER  = (float*) ((PyArrayObject *)dic_value ) ->data ;
  
  

  
  
#define AA(i,j,k)  a_data[(k)+dim_1*((j)+dim2*(i))  ]
  

  room_for_median = (float*) malloc( dim2*sizeof(float)  );


  dim_exponts = 2 * dim_fft;
  


  EXPONENTS  = malloc((dim_exponts) * sizeof(float));
  C_HST_EXPNT(dim_exponts, dim_fft*2, 8, EXPONENTS, &status);
  

  
  sum_line = (float*) malloc( dim_fft*sizeof(float)  );
  memset(sum_line,0,dim_fft*sizeof(float) );
  
  
  
  
  for(slice_count=0; slice_count< dim_3; slice_count++) {
    
    memset(sum_line,0,dim_fft*sizeof(float) );
    for(i=0; i< dim_1; i++) {
      

      /* copy memoire 
       */
      for( proj_count=0 ; proj_count< dim2; proj_count++) {
	room_for_median[proj_count] =  AA(  slice_count, proj_count, i) ;
      }
#define swap_float( a,b) tmp_swap=(a); (a)=(b); (b)=tmp_swap;


      /* bubble ordering 
       */
      for( k=1; k<dim2; k++) {
	count=0;
	for( l=0; l<dim2-k; l++) {

	  if( room_for_median[l]> room_for_median[l+1]  ){
	    swap_float(room_for_median[l] ,room_for_median[l+1]  );
	    count++;
	  }

	}
	if(count==0) break;
      }

      sum_line[i] = 0.5*( room_for_median[ dim2/2 ]
			+ room_for_median[ (int)(0.6+dim2/2.0 )] 
			  ) ;
    }


    
    /* Filtering */
    hst_ffa8__(&dim_fft , &dim_fft, &dim_exponts, EXPONENTS, &True  ,sum_line , &status);
    /******************************************************
     * Multiply the Fourier transformed array with filter *
     ******************************************************/    
    for(i=0;i<dim_fft;i++) {
      sum_line[i] = sum_line[i] * FILTER[i]/ dim_fft;
    }
    
    /***************************************************
     * Inverse Fourier transform to give convolution   *
     ***************************************************/
    
    hst_ffs8__(&dim_fft,&dim_fft, &dim_exponts, EXPONENTS, &True, sum_line, &status);
    
    
    /* Subtraction */
    for( proj_count=0 ; proj_count< dim2; proj_count++) {
      
      for(i=0; i< dim_1; i++) {
	
	AA(  slice_count, proj_count, i) -=  sum_line[i]  ;
	
      }
      
    }    
    
  }
  
  free(room_for_median);
  free(sum_line);
  
  Py_INCREF(Py_None);
  return Py_None;
  
  
}



static PyMethodDef SINO_Filter_functions [] = {
  {"Filter", Filter,  METH_VARARGS, Filter_doc},
  { NULL, NULL}
};






void 
__init__Filter__   (void)
{
  PyObject *m, *d;
  m = Py_InitModule(  __SINO_Filter_name__    ,  SINO_Filter_functions  );
  d = PyModule_GetDict(m);
  ErrorObject = Py_BuildValue("s",  __SINO_Filter_name__  ".error");
  PyDict_SetItemString(d,"error", ErrorObject);
  if(PyErr_Occurred())
    Py_FatalError("can't initialize module " __SINO_Filter_name__  );
  
#ifdef import_array
  import_array();
#endif
}



