/*
 * The PyHST program is Copyright (C) 2002-2011 of the
 * European Synchrotron Radiation Facility (ESRF) and
 * Karlsruhe Institute of Technology (KIT).
 *
 * PyHST is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * hst is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <string.h>

#include "hst_setup.h"

int hst_setup_init(HSTSetup *ctx) {
    assert(ctx);
    memset(ctx, 0, sizeof(HSTSetup));

    return 0;
}

void hst_setup_free(HSTSetup *ctx) {
    assert(ctx);
    if (ctx->maxX) free(ctx->maxX);
    if (ctx->minX) free(ctx->minX);
    if (ctx->axis_position_corr_s) free(ctx->axis_position_corr_s);
    if (ctx->sin_s) free(ctx->sin_s);
    if (ctx->cos_s) free(ctx->cos_s);
    if (ctx->filter) free(ctx->filter);
}
